//----------------------------------------------------------------------------------------------

// PasteStuff.cp

//----------------------------------------------------------------------------------------------

/*


*/

#include "PasteStuff.h"
#include "PasteJob.h"

//----------------------------------------------------------------------------------------------

/*


*/

static bool CanPasteFromPasteboard(PasteboardRef theClipboard,PasteboardItemID &GoodItemID)
{
  bool Result = false;
  short NbrForPowerCADD = 0;
  bool HasOpenClip = false;
  
  OSStatus err = noErr;
  
  ItemCount           itemCount;
  
  err = PasteboardGetItemCount(theClipboard,&itemCount);
  
  //NSLog(@"Pasteboard ItemCount: %d",itemCount);  // = 1
  
  for(UInt32 itemIndex = 1; itemIndex <= itemCount; itemIndex++) {
    PasteboardItemID    itemID;
    
    err = PasteboardGetItemIdentifier(theClipboard,itemIndex,&itemID);
    
    //NSLog(@"Pasteboard itemID: %d",itemID); // = 0
    
    CFArrayRef flavorTypeArray;
    err = PasteboardCopyItemFlavors(theClipboard,itemID,&flavorTypeArray);
    
    CFIndex flavorCount;
    flavorCount = CFArrayGetCount(flavorTypeArray);
    
    //NSLog(@"Pasteboard flavorCount: %d",flavorCount);  // = 5
    
    for(CFIndex flavorIndex = 0; (flavorIndex < flavorCount); flavorIndex++) {
      CFStringRef flavorType;
      flavorType = (CFStringRef)CFArrayGetValueAtIndex(flavorTypeArray,flavorIndex);
      
      //NSLog(@"flavorType: %@",flavorType); // com.engsw.pc8
                                           // dyn.agk8za3bfg6
                                           // com.adobe.pdf
                                           // com.apple.pict
      //CFStringRef nsPBoardFlavorType;
      //nsPBoardFlavorType = UTTypeCopyPreferredTagWithClass(flavorType,kUTTagClassNSPboardType);
      //NSLog(@"nsPBoardFlavorType: %@",nsPBoardFlavorType);
            // com.engsw.pc8    null
            // dyn.agk8za3bfg6  null
            // com.adobe.pdf    Apple PDF pasteboard type
            // com.apple.pict   Apple PICT pasteboard type
      //CFStringRef osTypeFlavorType;
      //osTypeFlavorType = UTTypeCopyPreferredTagWithClass(flavorType,kUTTagClassOSType);
      //NSLog(@"osTypeFlavorType: %@",osTypeFlavorType);
            // com.engsw.pc8    null
            // dyn.agk8za3bfg6  Pd%7
            // com.adobe.pdf    PDF
            // com.apple.pict   PICT
      
      if (UTTypeConformsTo(flavorType,CFSTR("com.engsw.pc8"))) {
        //NSLog(@"PC8 on clipboard");
        NbrForPowerCADD++;
      }
      else if (UTTypeConformsTo(flavorType,CFSTR("dyn.agk8za3bfg6"))) {
        //NSLog(@"PC7 on clipboard");
        NbrForPowerCADD++;
      }
      if (UTTypeConformsTo(flavorType,CFSTR("com.adobe.pdf"))) {
        //NSLog(@"PDF on clipboard");
        NbrForPowerCADD++;
      }
      else if (UTTypeConformsTo(flavorType,CFSTR("com.apple.pict"))) {
        //NSLog(@"PICT on clipboard");
        NbrForPowerCADD++;
      }
      else if (UTTypeConformsTo(flavorType,CFSTR("public.rtf"))) {  // text deal-killers
        //NSLog(@"RTF on clipboard");
        NbrForPowerCADD++;
      }
      else if (UTTypeConformsTo(flavorType,CFSTR("com.apple.traditional-mac-plain-text"))) {
        //NSLog(@"TEXT on clipboard");
        NbrForPowerCADD++;
      }
      else if (UTTypeConformsTo(flavorType,CFSTR("public.utf8-plain-text"))) {
        //NSLog(@"utf8 on clipboard");
        NbrForPowerCADD++;
      }
      else if (UTTypeConformsTo(flavorType,CFSTR("public.utf16-external-plain-text"))) {
        //NSLog(@"ut16 on clipboard");
        NbrForPowerCADD++;
      }
      else if (UTTypeConformsTo(flavorType,CFSTR("public.html"))) {
        //NSLog(@"HTML on clipboard");
        NbrForPowerCADD++;
      }
      else if (UTTypeConformsTo(flavorType,CFSTR("com.openclip.clip"))) {
        //NSLog(@"OpenClip on clipboard");
        HasOpenClip = true;
        GoodItemID = itemID;
      }
      
    };
    
  };
  
  if ((NbrForPowerCADD == 0) && HasOpenClip)
    Result = true;
    
  return Result;
};


OSErr HandledOpenClipPaste(void)
{
  OSErr TheEventHandlerErr = eventNotHandledErr;
    
  PasteboardRef theClipboard;
  
  PasteboardCreate(kPasteboardClipboard,&theClipboard);
  
  PasteboardItemID GoodItemID;
  if (CanPasteFromPasteboard(theClipboard, GoodItemID)) {
  
    CFDataRef TheData;
    PasteboardCopyItemFlavorData(theClipboard,GoodItemID,CFSTR("com.openclip.clip"),&TheData);
    
    NSDictionary *TheDocument = [NSKeyedUnarchiver unarchiveObjectWithData:(NSData *)TheData];
    
    if (TheDocument) {
      DWindow *theWindow = ActiveDrawingWindow();
      //PasteJob TheJob(theWindow,TheDocument);
      PasteJob TheJob(theWindow);
      TheJob.ReadTheDictionary(TheDocument);
    };
    
    CFRelease(TheData);
    
    TheEventHandlerErr = noErr;  // ie we handled it  
  }
  /*
  else {  // did not work right
    NSLog(@"Pasting from OpenClip File");
    DWindow *theWindow = ActiveDrawingWindow();  // paste from OpenClipFile
    
    PasteJob TheJob(theWindow);
    TheJob.ReadOpenClipFile();
    
    TheEventHandlerErr = noErr;  // ie we handled it  
  };
  */
  
  return TheEventHandlerErr;
};


//----------------------------------------------------------------------------------------------